
        Ctl-Opt  debug option(*NODEBUGIO : *SRCSTMT );
        Ctl-Opt  dftactgrp(*no) actgrp(*caller);
        Ctl-Opt  thread(*serialize);

      /COPY QSYSINC/QRPGLESRC,SQLFP

        dcl-pr CC1_FLDPRC              extpgm('CC1_FLDPRC');
           functionCode                int(5) const;
           optParms                    likeds(SQLFOPVD);
           decodeType                  likeds(SQLFPD);
           decodeData                  char(20);
           encodeType                  likeds(SQLFPD);
           encodeData                  char(40);
           sqlState                    char(5);
           sqlMsgText                  likeds(SQLFMT);
        end-pr;
        dcl-pi CC1_FLDPRC;
           functionCode                int(5) const;
           optParms                    likeds(SQLFOPVD);
           decodeType                  likeds(SQLFPD);
           decodeData                  char(20);
           encodeType                  likeds(SQLFPD);
           encodeData                  char(40);
           sqlState                    char(5);
           sqlMsgText                  likeds(SQLFMT);
        end-pi;

        dcl-c  INITIALIZE              8;
        dcl-c  ENCODE                  0;
        dcl-c  DECODE                  4;

        sqlState = '00000';

        select;

           // INITIALIZE
           // Called when FIELDPROC is initially added to the field.
           // This procedure returns the SQL Data Type that will be
           // used to store the encoded data.
            when functionCode = INITIALIZE;

                // Verify this FieldProc program only being used for
                // fixed-length character column.
                 if  decodeType.SQLFST <> 452
                 and decodeType.SQLFST <> 453;
                     // Return error for unsupported data type
                      sqlState = '38001';
                      sqlMsgText = 'Invalid data type for fieldproc';
                 else;
                     // The Encoded value has almost all of the same attributes
                     // as the decoded value...just need to change the length.
                      encodeType = decodeType;
                      encodeType.SQLFL = 40;
                      encodeType.SQLFBL = 40;
                 endif;


           // ENCODE
           // Called (usually) on write/update to encode the field.
            when functionCode = ENCODE;

                // make sure we don't encode a masked value !!
                 if %subst(decodeData:1:6) = '******';
                      sqlstate = '09501';
                      sqlMsgText = 'Encoding not valid for a masked value';
                 else;
                     // your logic to encrypt the data goes here...
                      encodeData = EncodeCard(decodeData);
                      sqlState = '00000';
                 endif;



           // DECODE
           // Called (usually) on read to decode the field.
            when functionCode = DECODE;
                // logic to encode the data goes here
                 decodeData = DecodeCard(encodeData);
                 sqlState = '00000';


           // Other
           // Any other functionCode is invalid
            when functionCode = DECODE;
                 SqlState = '38003';


        endsl;


        Return ;

       //---------------------------------------------------------------------
       // Procedure to encode data -------------------------------------------
       //---------------------------------------------------------------------
        dcl-proc  EncodeCard;
          dcl-pi  EncodeCard           char(40);
            inData                     char(20);
          end-pi;

          dcl-s   encodedText          char(40);
          dcl-s   len                  int(5);
          dcl-s   i                    int(5);

          len = %len(%trim(inData));

          for i = 1 to len;
            %subst(encodedText : i + (i-1) : 1) =
               %subst(inData : i : 1);
            %subst(encodedText : i + i : 1) =
               %subst(inData : len - (i-1) : 1);
          endfor;

          Return encodedText;

        end-proc  EncodeCard;


       //---------------------------------------------------------------------
       // Procedure to decode data -------------------------------------------
       //---------------------------------------------------------------------
        dcl-proc  DecodeCard;
          dcl-pi  DecodeCard           char(20);
            inData                     char(40);
          end-pi;

          dcl-s   decodedText          char(40);
          dcl-s   len                  int(5);
          dcl-s   i                    int(5);

          len = %len(%trim(inData));

          for i = 1 to len - 1 by 2;
            %subst(decodedText : %int((i+1)/2) : 1) =
               %subst(inData : i : 1);
          endfor;

          Return decodedText;

        end-proc  DecodeCard;
 